array byte appIds[10]

if init = 0
 init = 1
 id = 0
 refreshState = 0
 sportTelemetrySend( 0x17, 0x21, 0xFFFF, 0x80 )
 valueread = 0
 modified = 0
 strtoarray( appIds[0], "\x10\x20\x30\x50\x60\x70\x80\xA0\xB0\xD0" )
 vpos = 0
 index = 0
 appident = appIds[index] * 16
 tcount = 0
end

goto main

displaySensor:
if index < 10
 tindex = index * 9
 if vpos = 0
  attr = INVERS
	if edit then attr |= BLINK
 else
 	attr = 0
 end
 drawtext( 45, 16, "Vario   \0FAS     \0FLVSS   \0RPM     \0Fuel    \0Accel   \0GPS     \0Airspeed\0R.Bus   \0Gas suit"[tindex], attr )
end
return

incField:
 if param < max
  param += 1
 end
return

decField:
 if param > min
  param -= 1
 end
return

rem pass in param, min, max
checkIncDec:
 tcount += 1
 if Event = EVT_RIGHT_FIRST then gosub incField
 if Event = EVT_LEFT_FIRST then gosub decField
rem for encoder use:
 if Event = EVT_UP_FIRST then gosub decField
 if Event = EVT_DOWN_FIRST then gosub incField
return param


runpage:
 drawclear()
 drawtext( 0, 0, "Change Id", INVERS )
 drawtext( 0, 16, "Sensor:" )
 gosub displaySensor
 if vpos = 0
  if (Event = EVT_MENU_BREAK) | (Event = EVT_BTN_BREAK)
   if edit
  	edit = 0
	 else
	  edit = 1
   end
  end
  if edit
   param = index
	 min = 0
	 max = 9
	 gosub checkIncDec
	 if index # param then valueread = 0
	 index = param
   appident = appIds[index] * 16
  end
 end

 if vpos = 1
  attr = INVERS
 else
 	attr = 0
 end
 drawtext( 0, 24, "Read Id:", attr )
 if vpos = 1
  if (Event = EVT_MENU_BREAK) | (Event = EVT_BTN_BREAK)
   valueread = 0
   refreshState = 0
	end
 end

 attr = 0
 if vpos = 2
  if editId = 0 then attr = INVERS
 end
 drawtext( 0, 32, "Change Id:", attr )

 if valueread = 1
  if editId
   attr = INVERS
  else
  	attr = 0
  end
  drawnumber( 66, 24, id, attr )
 end

 if editId
  param = id
  min = 0
  max = 27
  gosub checkIncDec
  id = param
 end

 if vpos = 2
  if (Event = EVT_MENU_BREAK) | (Event = EVT_BTN_BREAK)
   if valueread = 1
 	  if editId
  	 editId = 0
	 	 modified = 1
	  else
	 	 editId = 1
    end
	 end
	end
 end

//drawnumber( 50, 40, index, 0 )
//drawnumber( 50, 48, edit, 0 )
//drawnumber( 50, 56, vpos, 0 )
//drawnumber( 80, 56, tcount, 0 )

//drawnumber( 127, 24, primId, 0 )
//drawnumber( 127, 32, dataId, 0 )
//drawnumber( 63, 32, appident, 0 )
//drawnumber( 127, 40, fieldId, 0 )
//drawnumber( 127, 48, value, 0 )
//drawnumber( 63, 56, scount, 0 )
//drawnumber( 127, 56, rcount, 0 )

 if edit = 0 & editId = 0
  if Event = EVT_UP_FIRST
	 if vpos > 0
	  vpos -= 1 
	 end
	end
  if Event = EVT_DOWN_FIRST
	 if vpos < 2
	  vpos += 1 
	 end
  end
 end
return

refresh:
 if refreshState = 0
  if retries = 2
    sportTelemetrySend( 0x17, 0x21, 0xFFFF, 0x80 )
		result = 1
	else
   result = sportTelemetrySend( 0x17, 0x30, appident, 0x01 )
	end
	sresult = result
  if result
   refreshState = 1
   telemetryPopTimeout = gettime() + 80
  end
 elseif refreshState = 1
	result = sportTelemetryReceive( physicalId, primId, dataId, value )
	cresult = result
	rcount += 1
	scount += 1
  if result > 0
   if primId = 0x32
    if dataId = appident
     result = 2
     fieldId = value & 0x00FF
		 refreshState = 2
		 if fieldId = 0x01
      value /= 256
      id = value
			valueread = 1
     end
		end
	 end
	end
  if result # 2
   if gettime() > telemetryPopTimeout
    refreshState = 0
		retries += 1
		if retries > 4
		 retries = 0
    end
   end
  end
 end
 if refreshState = 2
  if modified
   sportTelemetrySend( 0x17, 0x31, appident, 0x01 + id*256)
	 modified = 0
	end
 end
return


main:
 if Event = EVT_EXIT_BREAK then goto done
 if Event = 0x81 then goto done
 gosub refresh
 gosub runpage

stop
done:
 sportTelemetrySend( 0x17, 0x20, 0xFFFF, 0x80 )
finish

